unit multimedia;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  CustSaveIt, AlmostSave, MDISaveIt, MPlayer, ExtCtrls, GenericSave;

type
  TMultimediaChild = class(TForm)
    MultimediaChildSaveIt: TMDIChildSaveIt;
    Panel1: TPanel;
    MediaPlayer1: TMediaPlayer;
    MoviePanel: TPanel;
    procedure MultimediaChildSaveItCreated(Sender: TObject);
    procedure MultimediaChildSaveItDataLoad(Sender: TObject;
      FileName: String; var Success: Boolean);
    procedure MediaPlayer1Click(Sender: TObject; Button: TMPBtnType;
      var DoDefault: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MultimediaChild: TMultimediaChild;

implementation

{$R *.DFM}

// *** Begin Ignorable Code ***

procedure TMultimediaChild.MultimediaChildSaveItCreated(Sender: TObject);
begin
  // Set MoviePanel's Captions depending on what data type is being opened or created
  with TMDIChildSaveIt(Sender) do
    if FileTypeExt = 'wav' then MoviePanel.Caption := 'Wave Sound' else
    if FileTypeExt = 'mid' then MoviePanel.Caption := 'MIDI File' else
    if FileTypeExt = 'avi' then MoviePanel.Caption := 'AVI Movie';
end;

procedure TMultimediaChild.MediaPlayer1Click(Sender: TObject;
  Button: TMPBtnType; var DoDefault: Boolean);
begin
  // Clear Caption When Movie Plays
  if (Button = btPlay) and (mpUsesWindow in MediaPlayer1.Capabilities) then
    MoviePanel.Caption := '';
end;

// *** End Ignorable Code ***

// *** Begin Important Code ***

procedure TMultimediaChild.MultimediaChildSaveItDataLoad(Sender: TObject;
  FileName: String; var Success: Boolean);
begin
  MediaPlayer1.FileName := FileName;
  MediaPlayer1.Open;
end;

// *** End Important Code ***

end.
