unit Main;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls, GenericSave,
  MDISaveIt;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    FileNewItem: TMenuItem;
    FileOpenItem: TMenuItem;
    FileCloseItem: TMenuItem;
    Window1: TMenuItem;
    N1: TMenuItem;
    FileExitItem: TMenuItem;
    WindowCascadeItem: TMenuItem;
    WindowTileItem: TMenuItem;
    WindowArrangeItem: TMenuItem;
    FileSaveItem: TMenuItem;
    FileSaveAsItem: TMenuItem;
    WindowMinimizeItem: TMenuItem;
    SpeedPanel: TPanel;
    OpenBtn: TSpeedButton;
    StatusBar: TStatusBar;
    SaveButton: TSpeedButton;
    SaveAsButton: TSpeedButton;
    CloseButton: TSpeedButton;
    N2: TMenuItem;
    N3: TMenuItem;
    FileCloseAllItem: TMenuItem;
    NewButton: TSpeedButton;
    MDISaveIt1: TMDISaveIt;
    MDISaveItType1: TMDISaveItType;
    procedure WindowCascadeItemClick(Sender: TObject);
    procedure WindowTileItemClick(Sender: TObject);
    procedure WindowArrangeItemClick(Sender: TObject);
    procedure FileExitItemClick(Sender: TObject);
    procedure WindowMinimizeItemClick(Sender: TObject);
    procedure MDISaveItType1FileNew(Sender: TObject; var Proceed: Boolean;
      var NewChild: TForm);
    procedure MDISaveIt1AllowClose(Sender: TObject; Allowed: Boolean);
    procedure MDISaveIt1AllowSave(Sender: TObject; Allowed: Boolean);
    procedure MDISaveIt1AllowSaveAs(Sender: TObject; Allowed: Boolean);
    procedure FileOpenItemClick(Sender: TObject);
    procedure FileSaveItemClick(Sender: TObject);
    procedure FileSaveAsItemClick(Sender: TObject);
    procedure FileCloseItemClick(Sender: TObject);
    procedure FileCloseAllItemClick(Sender: TObject);
    procedure FileNewItemClick(Sender: TObject);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses ChildWin;

// *** Begin Ignorable Code ***

procedure TMainForm.FileExitItemClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.WindowCascadeItemClick(Sender: TObject);
begin
  Cascade;
end;

procedure TMainForm.WindowTileItemClick(Sender: TObject);
begin
  Tile;
end;

procedure TMainForm.WindowArrangeItemClick(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure TMainForm.WindowMinimizeItemClick(Sender: TObject);
var
  I: Integer;
begin
  { Must be done backwards through the MDIChildren array }
  for I := MDIChildCount - 1 downto 0 do
    MDIChildren[I].WindowState := wsMinimized;
end;

// *** End Ignorable Code ***

// *** Begin Important Code ***

procedure TMainForm.MDISaveItType1FileNew(Sender: TObject;
  var Proceed: Boolean; var NewChild: TForm);
begin
  // Create Child Window
  NewChild := TMDIChild.Create(Application);

{ Example: How to display a dialog (or anything else requiring user input)
           within this Event. It is necessary to do it this way because
           user-input is this event is disabled for the entire application.
  -----------------------------------------------------------------------
  Note: This is only necessary for OnFileNew, do not use EnableApp or
        DisableApp in the OnFileOpen Event! So If you're going to use
        EnableApp/DisableApp please make sure TMDISaveItType.OnFileOpen
        does not point to the OnFileNew event handler (as is the default
        case with this template/demo)
  -----------------------------------------------------------------------

  with MDIChildSaveIt1.MDISaveIt do
  try
    EnableApp;
    ShowMessage('This is my dialog.');
  finally
    DisableApp; // Important, don't forget!
  end;
}

end;

procedure TMainForm.MDISaveIt1AllowClose(Sender: TObject;
  Allowed: Boolean);
begin
  // Enable/Disable Close
  FileCloseItem.Enabled    := Allowed;
  FileCloseAllItem.Enabled := Allowed;
  CloseButton.Enabled      := Allowed;

  // Enable/Disable Window Menu
  Window1.Enabled := Allowed;
end;

procedure TMainForm.MDISaveIt1AllowSave(Sender: TObject; Allowed: Boolean);
begin
  // Enable/Disable Save
  FileSaveItem.Enabled := Allowed;
  SaveButton.Enabled   := Allowed;
end;

procedure TMainForm.MDISaveIt1AllowSaveAs(Sender: TObject;
  Allowed: Boolean);
begin
  // Enable/Disable SaveAs
  FileSaveAsItem.Enabled := Allowed;
  SaveAsButton.Enabled   := Allowed;
end;

procedure TMainForm.FileOpenItemClick(Sender: TObject);
begin
  // Open File
  MDISaveIt1.Open;
end;

procedure TMainForm.FileSaveItemClick(Sender: TObject);
begin
  // Save File
  MDISaveIt1.Save;
end;

procedure TMainForm.FileSaveAsItemClick(Sender: TObject);
begin
  // Save File As...
  MDISaveIt1.SaveAs;
end;

procedure TMainForm.FileCloseItemClick(Sender: TObject);
begin
  // Close Current File
  MDISaveIt1.Close;
end;

procedure TMainForm.FileCloseAllItemClick(Sender: TObject);
begin
  // Close All Files
  MDISaveIt1.CloseAll;
end;

procedure TMainForm.FileNewItemClick(Sender: TObject);
begin
 {-----------------------------------------------------------------------------}
 { New File                                                                    }
 {-----------------------------------------------------------------------------}
 { We use .NewDefault instead of .New since .New calls up the New Dialog which }
 { is unnecessary if you only have one file type.                              }
 {-----------------------------------------------------------------------------}
  MDISaveIt1.NewDefault;
end;

// *** End Important Code ***

end.
